<template>
   <div>
        <base-card>
            <div class="controls">
            <base-button mode="delineado" link to="/registro_cita">Nueva Cita</base-button>
            </div>
            <filtro-cita @cambio-filtro="setFiltro"></filtro-cita>
            <div v-if="enCargaCitas">
            <base-spinner></base-spinner>
            </div>
            <ul v-else-if="existenCitas && filtradoCitas.length>0">
                <item-cita v-for="cita in filtradoCitas" 
                :key="cita.id" 
                :id="cita.id"
                :nombre="cita.nombre"
                :hora="cita.hora"
                :dia="cita.dia"
                :estatus="cita.estatus"></item-cita>
            </ul>
            <h3 v-else>No se encuentran citas.</h3>
            </base-card>
    </div> 
</template>
<script>
import ItemCita from '../citas/ItemCita.vue';
import FiltroCita from '../citas/FiltroCita.vue';
export default {
    components:{
        ItemCita,
        FiltroCita
    },
    data() {
        return{
            enCargaCitas: false,
            filtrosActivos:{
                    enespera:true,
                    confirmado:true,
                    terminado:false
                },
        };
        
    },
    computed:{
        filtradoCitas(){
            const citas= this.$store.getters['citas/citas'];
            console.log(citas);
            return citas.filter(cita=>{
                if(this.filtrosActivos.enespera&&cita.estatus.includes('En espera')){
                    return true;
                }
                if(this.filtrosActivos.confirmado&&cita.estatus.includes('Confirmado')){
                    return true;
                }
                if(this.filtrosActivos.terminado&&cita.estatus.includes('Terminado')){
                    return true;
                }
                return false;
            });
        },
        existenCitas(){
            return !this.enCargaCitas && this.$store.getters['citas/existenCitas'];
        },
    },
    created(){
        this.cargarCitas();
    },
    methods:{
        setFiltro(filtroActualizado){
            this.filtrosActivos=filtroActualizado;
        },
        async cargarCitas(){
            this.enCargaCitas=true;
            await this.$store.dispatch('citas/cargarCitas');
            this.enCargaCitas=false;
        },
    }
}
</script>
<style scoped>
.contenido{
    margin-top: 5rem;
}
.controls {
  display: flex;
  justify-content: space-between;
}
ul {
  list-style: none;
  margin: 0;
  padding: 0;
}
button:active,
button:hover,
button.base-button-active {
  border: 1px solid white;
}
</style>